;Sprite Drawing Routine (SDR): 16 (+) bit version, normal
;by JL <JayEll64@aol.com>
;inputs:
;	b=x coordinate
;	c=y coordinate
;	hl=pointer to sprite data
;sprite data stored like:
;
;.db (# of bytes across),(# of rows down)
;.db (sprite data)
;
;size=70 bytes (+6 pushes/pops)
SDR16:
 ld a,63	;-->flip x coordinate around for FIND_PIXEL
 sub c		; / may be removed if you account for it in your program
 ld c,a		;/	(save 4 bytes!)
 push hl	;push hl to the stack
 call FIND_PIXEL	;make a FIND_PIXEL
 ld de,VIDEO_MEM	;define offset
 add hl,de	;and add offset
 ex (sp),hl	;exchange video location with sprite pointer
 ld e,(hl)	;e=width of sprite
 inc hl	;next byte
 ld d,(hl)	;d=height of sprite
 inc hl	;next byte (now points to actual sprite)
 ex (sp),hl	;trade back
 pop ix	;pop sprite pointer back as ix

 add a,a	;->sets all bits to the right of the set bit in reg a
 dec a		;/ for example, if a=%00010000 before, a=%00011111 aft
 ld c,a	;save mask into reg c
 ld a,b	;a=x coor
 and %00000111	;find remainder of a/8 (x coor divided by 8)
 inc a	;increase to get range of 1-8
 ld b,a	;and save into reg b

SDRP_NewRow:
 push de	;save counters
 push hl	;save where to place sprite
SDRP_NewCol:
 push bc	;save rotate counter and mask
 ld a,(ix)	;load byte in sprite into a
 inc ix	;ready for next byte

 rlca	;rotate left...
SDRP_PrepByte:
 rrca	;then rotate right b times (if b=1, stays the same, else shifts)
 djnz SDRP_PrepByte	;repeat

 ld b,a	;save a into b
 and c	;mask off bits
 ld d,a	;save into d
 ld a,c	;get mask
 cpl	;coplement every bit
 and (hl)	;and mask off all bits where sprite's going to be
 or d	;and set bits for sprite
 ld (hl),a	;load into video mem
 inc hl	;next byte over

 ld a,c	;load mask into a
 cpl
 and b	;mask off other half of bits
 ld d,a	;does the same thing as the first part does
 ld a,c
 and (hl)
 or d
 ld (hl),a

 pop bc	;restore rotate counter and mask
 dec e	;decrease width
 jr nz,SDRP_NewCol	;if not done, repeat
 pop hl	;restore video mem pointer
 ld de,$10	;de=$10
 add hl,de	;move hl one row down
 pop de	;restore counter
 dec d	;decrease number of rows
 jr nz,SDRP_NewRow	;if not done, repeat
 ret	;return to main program