;Sprite Drawing Routine (SDR): 16 (+) bit version, white transparency
;by JL <JayEll64@aol.com>
;inputs:
;	b=x coordinate
;	c=y coordinate
;	hl=pointer to sprite data
;sprite data stored like:
;
;.db (# of bytes across),(# of rows down)
;.db (sprite data)
;
;size=63 bytes (+6 pushes/pops)
;Use SDR8 for sprites with only a one byte width!!
SDR16WT:
 ld a,63	;-->flip y coordinate around for FIND_PIXEL
 sub c		; / may be removed if you account for it in your program
 ld c,a		;/
 push hl	;save pointer to sprite
 call FIND_PIXEL	;make a FIND_PIXEL
 ld de,VIDEO_MEM	;beginning of video mem
 add hl,de	;add offset
 ex (sp),hl	;hl(pointer to video location)<->(sp)(pointer to sprite)
 ld e,(hl)	;e=width
 inc hl	;next byte
 ld d,(hl)	;d=height
 inc hl	;next byte
 ex (sp),hl	;trade back
 pop ix	;and pop pointer to sprite back as ix

 add a,a	;->sets all bits to the right of the set bit in reg a
 dec a		;/ for example, if a=%00010000 before, a=%00011111 aft
 ld c,a	;save mask into reg c
 ld a,b	;a=x coor
 and %00000111	;find remainder of a/8 (x coor divided by 8)
 inc a	;increase to get range of 1-8
 ld b,a	;and save into reg b

SDR16WT_NewRow:
 push de	;save counters
 push hl	;save where to place sprite
SDR16WT_NewCol:
 push bc	;save rotate counter and mask
 ld a,(ix)	;load byte in sprite into a
 inc ix	;ready for next byte

 rlca	;rotate left...
SDR16WT_PrepByte:
 rrca	;then rotate right b times (if b=1, stays the same, else shifts)
 djnz SDR16WT_PrepByte	;repeat

 ld b,a	;save a into b
 and c	;mask off bits
 or (hl)	;or it with whats already at that spot in video mem
 ld (hl),a	;and load into video mem
 inc hl	;next byte over

 ld a,c	;load mask into a
 cpl	;xor 255 (switches every byte)
 and b	;mask off other half of bits
 or (hl)	;same as above
 ld (hl),a	;same as above

 pop bc	;restore rotate counter and mask
 dec e	;decrease width
 jr nz,SDR16WT_NewCol	;if not done, repeat
 pop hl	;restore video mem pointer
 ld de,$10	;de=$10
 add hl,de	;move hl one row down
 pop de	;restore counter
 dec d	;decrease number of rows
 jr nz,SDR16WT_NewRow	;if not done, repeat
 ret	;return to main program